//-----------------------------------------------------------------------------
// GA2K
//
// ISDL, Doshisha University Distributed Genetic Algorithm Software
// Version 1.2
//-----------------------------------------------------------------------------
// Parallel Genetic Algorithm Team of Intelligent Systems Design Laborato
// ry, Doshisha University.
//
// Version 0.1: 1999/05/05
// Copyright (C) 1999 Jun-ichi Yoshida and Ikki Ohmukai, All rights reserved.
// Version 1.0: 2001/12/13
// Copyright (C) 2001 Jun-ichi Yoshida, Tomoyuki Hiroyasu and Mitsunori Miki,
// All rights reserved.
// Version 1.1: 2002/01/17
// Copyright (C) 2002 Jun-ichi Yoshida, Masaki Sano, Tomoyuki Hiroyasu and Mitsunori Miki, All rights reserved.
// Version 1.2: 2002/06/04
// Copyright (C) 2002 Jun-ichi Yoshida, Masaki Sano, Tomoyuki Hiroyasu and Mitsunori Miki, All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
// 1. Redistributions of source code must retain the above copyright
//    notce and this list of conditions.
// 2. Redistributions in binary form must reproduce the above  copyright
//    notice and this list of conditions in the documentation and/or other
//    materials provided with the distribution.
// 3. The names of copyrighters of this software  should not be used to
//    endorse or promote products derived from this software without specific
//    prior written permission.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// ga2k_main.cpp
//-----------------------------------------------------------------------------

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
using namespace std;

#include "ga2k.h"


main(int argc, char *argv[])
{
	int i, trial;
	Globe globe;

	if(argc < 2)
		globe.initialize();
	else
		globe.initialize(argc, argv);

	globe.sumFitness.resize(globe.maxGeneration);

	for(i = 0; i < globe.maxGeneration; i++)
			globe.sumFitness[i] = 0;


	for(trial = 0; trial < globe.maxTrial; trial++)
	{
		globe.establish();

		if(trial == 0)
			globe.showParameters();

		cerr << "trial " << trial + 1 << " |" << endl;
		globe.execute();

		cerr << endl << "fitness    : " << globe.maxFitness << endl;
		cerr << "generation : " << globe.convGeneration << endl;
		cerr << "evaluate   : " << globe.totalEvaluate << endl;

	}

	if(globe.fOutput)
		for(i = 0; i < globe.maxGeneration; i++)
			cout << globe.sumFitness[i] / globe.maxTrial << endl;
}
