#ifndef _RANDRING_H_
#define _RANDRING_H_

#include "mtrand.h"

class RandomRing
{
private:
	int *ar;
	int sz;
	MTRand mt;
	int *work;

public:
	void srand(int n) {mt.srand(n);}
	void shuffle(int deepness = 1)
	{
		int i;
		for(i = 0; i < deepness * sz;)
		{
			int ind_a = mt.genrand_int(sz);
			int ind_b = mt.genrand_int(sz);
			int& a = work[ind_a];
			int& b = work[ind_b];

			if(a == ind_b || b == ind_a)
				continue;

			int tmp = a;
			a = b;
			b = tmp;
			i++;
		}
		for(i = 0; i < sz; i++)
		  {
		    ar[work[i]] = work[(i+1) % sz];
		  }
	}

	void resize(int n)
	{
		if(ar) delete[] ar;
		ar = new int[n * 2];
		work = ar + n;
		int i;
		for(i = 0; i < n; i++)
			work[i] = (i + 1) % n;

		sz = n;
		shuffle();
	}

	explicit RandomRing(int n) : ar(NULL) {resize(n);}
	RandomRing(int n, int seed) : ar(NULL) {srand(seed); resize(n);}
	~RandomRing() {delete[] ar;}
	inline const int *array() {return ar;}
	inline int operator[](int n) const {return ar[n];}
	inline int size() const {return sz;}
};

#endif // _RANDRING_H_
